#include <Wire.h>
#include "SSD1306Wire.h"
#include "images.h"
#include "fontovi.h"

SSD1306Wire  display(0x3c, 21, 22);

#define DEMO_DURATION 3000
typedef void (*Demo)(void);

float zidx[4];
int prazan[4];
int razmak=32;
int sirinaProlaza=10;

int joyPinX = A0; // Pin analogico para el eje X del joystick
int joyPinY = A1; // Pin analogico para el eje Y del joystick
int joyThreshold = 400; // Umbral para ignorar ruido del joystick

void setup() {
  Serial.begin(9600);
  pinMode(2, OUTPUT);
  pinMode(23, OUTPUT);
  display.init();
  for(int i=0;i<4;i++) {
    zidx[i]=128+((i+1)*razmak);
    prazan[i]=random(8,32);
  }
  display.flipScreenVertically();
  display.setFont(ArialMT_Plain_10);
}

int score=0;
float fx=30.00;
float fy=22.00;
int smjer=0;
unsigned long trenutno=0;
int igra=0;

void loop() {
  display.clear();

  if(igra==0) {
    display.setFont(ArialMT_Plain_16);
    display.drawString(0, 4, "Flappy ");
    display.drawXbm(0, 0, 128, 64, pozadina);
    display.drawXbm(20, 32, 14, 9, ptica);
    display.setFont(ArialMT_Plain_10);
    display.drawString(0, 44, "press to start");
    if(analogRead(joyPinY) < joyThreshold) {
      igra=1;
    }
  }

  if(igra==1) {
    display.setFont(ArialMT_Plain_10);
    display.drawString(3, 0, String(score));

    for(int j=0;j<4;j++) {
      display.setColor(WHITE);
      display.fillRect(zidx[j], 0, 6, 64);
      display.setColor(BLACK);
      display.fillRect(zidx[j], prazan[j], 6, sirinaProlaza);
    }

    display.setColor(WHITE);
    display.drawXbm(fx, fy, 14, 9, ptica);

    for(int j=0;j<4;j++) {
      zidx[j]=zidx[j]-0.01;
      if(zidx[j]<-7) {
        score=score+1;
        digitalWrite(23, 1);
        prazan[j]=random(8,32);
        zidx[j]=128;
      }
    }

    fy += (analogRead(joyPinY) - 10) * 0.01; // Ajusta la posición Y con el joystick

    if(fy < 0) fy = 0; // Evita que la posición Y sea menor que 0
    if(fy > 55) fy = 55; // Evita que la posición Y sea mayor que 55

    if(fy > 63 || fy < 0) {
      igra=0;
      fy=22;
      score=0;
      digitalWrite(23, 1);
      delay(500);
      digitalWrite(23, 0);
      for(int i=0;i<4;i++) {
        zidx[i]=128+((i+1)*razmak);
        prazan[i]=random(8,32);
      }
    }

    for(int m=0;m<4;m++) {
      if(zidx[m]<=fx+7 && fx+7<=zidx[m]+6) {
        if(fy<prazan[m] || fy+8>prazan[m]+sirinaProlaza) {
          igra=0;
          fy=22;
          score=0;
          digitalWrite(23, 1);
          delay(500);
          digitalWrite(23, 0);
          for(int i=0;i<4;i++) {
            zidx[i]=128+((i+1)*razmak);
            prazan[i]=random(8,32);
          }
        }
      }
    }

    display.drawRect(0, 0, 128, 64);
  }

  display.display();
}
